<template>
    <div>
        <div class="uk-margin-bottom" uk-grid>
            <div><h2>Connexion</h2></div>
            <div v-if="chargement" uk-spinner></div>
        </div>
        <div>
            <form
                class="uk-form-horizontal uk-margin-large uk-margin-medium-bottom"
            >
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Email</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="email"
                        v-model="email"
                    />
                </div>
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Mot de passe</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="password"
                        style="-webkit-text-security: circle"
                        v-model="password"
                    />
                </div>
            </form>
        </div>
        <div class="uk-text-danger uk-margin-bottom" v-if="messageErreur">
            {{ messageErreur }}
        </div>
        <div class="uk-margin-remove-bottom">
            <button
                class="uk-button uk-button-default button-connexion uk-align-center"
                @click="envoiInscription()"
            >
                Se connecter
            </button>

            <BoutonGoogle />
        </div>
    </div>
</template>

<script lang="ts">
import Axios from '@/auth/axiosAuth';
import UIkit from 'uikit';
import Utilisateur from '@/classes/Utilisateur';
import BoutonGoogle from './BoutonGoogle.vue';

export default {
    components: {
        BoutonGoogle,
    },

    data() {
        return {
            email: '',
            password: '',
            messageErreur: '',
            chargement: false
        };
    },

    methods: {
        envoiInscription(): void {
            this.chargement = true;
            const formData = new FormData();
            formData.append('email', this.email);
            formData.append('password', btoa(this.password));
            Axios.postConnexion(
                'auth/login/',
                (next) => {
                    UIkit.modal('#auth-modal').hide();
                    const token = next.data.accessToken;
                    const user = new Utilisateur();
                    user.mapperJson(next.data.user);
                    this.chargement = false;
                    this.$auth.login(user, token, true);
                },
                formData,
                (error) => {
                    if (
                        error.response != null &&
                        (error.response.status == 403 ||
                            error.response.status == 401)
                    ) {
                        if (error.response.data != null && error.response.data.message == 'Sans mot de passe') {
                            this.messageErreur =
                                'Un email vous a été envoyé pour réinitialiser votre mot de passe. Vous rencontrez cette situation soit parce que vous vous connectez habituellement avec une autre moyen de connexion ne nécessitant pas de mot de passe, soit suite à une migration technique (changement dans le stockage des mots de passe).';
                        } else {
                            this.messageErreur =
                                'Les informations renseignées ne permettent pas de se connecter.';
                        }
                        
                    }
                    this.chargement = false;
                },
            );
        },
    },
};
</script>
<style scoped>
.button-connexion {
    width: 60%;
    margin-bottom: 8px;
    margin-top: 0px !important;
}
</style>
